import { actionPromise } from "../../store/store";
import history from '../../history';

const getGQL = (url, headers = {}) => (query = "", variables = {}) =>
  fetch(url, {
    method: "POST",
    headers: {
      Accept: "application/json",
      "Content-Type": "application/json",
      ...headers,
    },
    body: JSON.stringify({ query, variables }),
  }).then((res) => res.json());

const actionPutPasswordPromise = (email, password) => {
  let promise = getGQL("http://localhost:3330/graphql")(
    `mutation chanPass($email: String, $password:String){
      changePassword(email:$email, password:$password){id, email, login}
    }`,
    { email, password }
  );
    return actionPromise("putPassword", promise);
};

const actionPutPassword = (email, password) => {
  return async (dispatch) => {
    let token = await dispatch(actionPutPasswordPromise(email, password));
    if(token.data.changePassword.login !== null) history.push("/")
  };
};

export { actionPutPassword };
