import { actionPromise } from "../../store/store";
import history from '../../history';

const getGQL = (url, headers = {}) => (query = "", variables = {}) =>
  fetch(url, {
    method: "POST",
    headers: {
      Accept: "application/json",
      "Content-Type": "application/json",
      ...headers,
    },
    body: JSON.stringify({ query, variables }),
  }).then((res) => res.json())

const actionLoginPromise =  (login, password) => {
  var promise =  getGQL("http://localhost:3330/graphql")(
    `query l($login:String, $password:String){
        getLogin(login:$login, password:$password)
        }`,
    { login, password }
  )
  return actionPromise("login", promise);
};

const actionLogin = (login, password) => {
  return async (dispatch) => {
    var token = await dispatch(actionLoginPromise(login, password));
    if(token.data.getLogin !== null) history.push("/my_profile")
  };
};

export { actionLogin };
